#pragma once

#include "TGlobal.h"
#include "TTools.h"
#include "FormGainDlg.h"
#include "FormAboutDlg.h"
#include "FormMovePhaseDlg.h"
#include "FormCheckClickNoiseDlg.h"
#include "FormRepairClickNoiseDlg.h"
#include "FormDCOffsetDlg.h"
#include "FormPreferencesDlg.h"

namespace AudioFixLite {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;
	using namespace System::IO;
//	using namespace System::Threading;

	PointF GetDpiMagnif();
		
	/// <summary>
	/// FormMain ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class FormMain : public System::Windows::Forms::Form
	{
	public:
		FormMain(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^ R[hǉ܂
			//
			Font = System::Drawing::SystemFonts::MessageBoxFont;
			mainMenuStrip->Font = System::Drawing::SystemFonts::MenuFont;
            fileToolStripMenuItem->Font = System::Drawing::SystemFonts::MenuFont;
            audioToolStripMenuItem->Font = System::Drawing::SystemFonts::MenuFont;
            helpToolStripMenuItem->Font = System::Drawing::SystemFonts::MenuFont;
            expToolStripMenuItem->Font = System::Drawing::SystemFonts::MenuFont;
			PointF dpiMagnif = GetDpiMagnif();
			float magnif = max(dpiMagnif.X * CurrentAutoScaleDimensions.Width / AutoScaleDimensions.Width, dpiMagnif.Y * CurrentAutoScaleDimensions.Height / AutoScaleDimensions.Height);
			mainToolStrip->ImageScalingSize = System::Drawing::Size(mainToolStrip->ImageScalingSize.Width * magnif, mainToolStrip->ImageScalingSize.Height * magnif);

			//theGlobal->Init();
			m_files = new TAudioFileProcess;
			m_csFileList = new TCriticalSection;
			m_priorities = gcnew ArrayList();
			
			m_encodeProgress = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackEncodeProgress));
			m_files->EncodeProgress = m_encodeProgress->GetGlue();
			m_encodeFinishOne = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackEncodeFinishOne));
			m_files->EncodeFinishOne = m_encodeFinishOne->GetGlue();
			m_commonProgress = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackCommonProgress));
			m_files->CommonProgress = m_commonProgress->GetGlue();

			m_commonStartOne = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackCommonStartOne));
			m_files->CommonStartOne = m_commonStartOne->GetGlue();

			m_commonFinishOne = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackCommonFinishOne));
			m_files->CommonFinishOne = m_commonFinishOne->GetGlue();

			m_commonFinish = gcnew TGenericCallbackGlue(this, gcnew TGenericCallbackGlue::CallbackDelegate(this, &AudioFixLite::FormMain::CallbackCommonFinish));
			m_files->CommonFinish = m_commonFinish->GetGlue();
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~FormMain()
		{
			delete m_files;
			delete m_csFileList;

			if (components)
			{
				delete components;
			}
		}

	protected: 
	private: System::Windows::Forms::MenuStrip^  mainMenuStrip;
	private: System::Windows::Forms::ToolStripMenuItem^  fileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  exitToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  audioToolStripMenuItem;


	private: System::Windows::Forms::ListView^  lvFileList;
	private: System::Windows::Forms::ColumnHeader^  clmStatus;
	private: System::Windows::Forms::ColumnHeader^  clmArtist;
	private: System::Windows::Forms::ColumnHeader^  clmWave;





	private: System::Windows::Forms::ToolStripMenuItem^  startEncodeToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  stopEncodeToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  clearFileListToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  addWAVEFileToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  saveID3ToolStripMenuItem;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator1;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripSeparator2;
	private: System::Windows::Forms::ToolStrip^  mainToolStrip;
	private: System::Windows::Forms::ToolStripButton^  startEncodeToolStripButton;
	private: System::Windows::Forms::ToolStripButton^  stopEncodeToolStripButton;
	private: System::Windows::Forms::StatusStrip^  mainStatusStrip;


	private: System::Windows::Forms::OpenFileDialog^  openWaveFileDialog;
	private: System::Windows::Forms::ToolStripMenuItem^  setupToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  setupACMCodecToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  encoderToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  selectACMCodecToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  selectLameToolStripMenuItem;
	private: System::Windows::Forms::ToolStripProgressBar^  mainToolStripProgressBar;
	private: System::Windows::Forms::ToolStripMenuItem^  setupLameToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  priorityToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  highestToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  highToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  normalToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  lowToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  lowestToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  saveFilesToToolStripMenuItem;
	private: System::Windows::Forms::FolderBrowserDialog^  saveWaveFilesToDialog;


	private: System::Windows::Forms::ColumnHeader^  clmAlbum;


	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem1;
	private: System::Windows::Forms::ToolStripMenuItem^  saveMergeFileToolStripMenuItem;
	private: System::Windows::Forms::SaveFileDialog^  saveMergeFileDialog;
	private: System::Windows::Forms::ColumnHeader^  clmGain;
	private: System::Windows::Forms::ColumnHeader^  clmHz;
	private: System::Windows::Forms::ColumnHeader^  clmBits;
	private: System::Windows::Forms::ColumnHeader^  clmCh;
	private: System::Windows::Forms::ColumnHeader^  clmTime;
	private: System::Windows::Forms::ColumnHeader^  clmMp3;
	private: System::Windows::Forms::ToolStripMenuItem^  gainToolStripMenuItem;
	private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem2;
	private: System::Windows::Forms::ColumnHeader^  clmMax;
private: System::Windows::Forms::ToolStripMenuItem^  checkMaxToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  helpToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  aboutToolStripMenuItem;
private: System::Windows::Forms::ColumnHeader^  clmMaxPos;
private: System::Windows::Forms::ColumnHeader^  clmLoud;
private: System::Windows::Forms::ToolStripButton^  checkMaxToolStripButton;
private: System::Windows::Forms::ToolStripMenuItem^  checkPhaseGapToolStripMenuItem;
private: System::Windows::Forms::ColumnHeader^  clmPhaseGap;
private: System::Windows::Forms::ColumnHeader^  clmMovePhase;
private: System::Windows::Forms::ToolStripMenuItem^  movePhaseToolStripMenuItem;
private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem3;
private: System::Windows::Forms::ToolStripMenuItem^  expToolStripMenuItem;

private: System::Windows::Forms::ToolStripMenuItem^  yToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  checkClickNoiseToolStripMenuItem;
private: System::Windows::Forms::ColumnHeader^  clmClickNoiseCount;
private: System::Windows::Forms::ColumnHeader^  clmDeClickNoise;
private: System::Windows::Forms::ToolStripMenuItem^  repairClickNoiseToolStripMenuItem;
private: System::Windows::Forms::SaveFileDialog^  saveWaveFileDialog;
private: System::Windows::Forms::ToolStripMenuItem^  saveWaveFileToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  repairDCOffsetToolStripMenuItem;

private: System::Windows::Forms::ColumnHeader^  clmMoveDcOffset;

private: System::Windows::Forms::ColumnHeader^  clmAverage;
private: System::Windows::Forms::FontDialog^  fontDialog;
private: System::Windows::Forms::ToolStripMenuItem^  viewToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  fontToolStripMenuItem;
private: System::Windows::Forms::ToolStripMenuItem^  preferencesToolStripMenuItem;
private: System::Windows::Forms::ToolStripSeparator^  toolStripMenuItem4;

























	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(FormMain::typeid));
			this->mainMenuStrip = (gcnew System::Windows::Forms::MenuStrip());
			this->fileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->clearFileListToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->addWAVEFileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveFilesToToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveWaveFileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->saveMergeFileToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->preferencesToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem4 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->exitToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->viewToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->fontToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->audioToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->encoderToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->selectACMCodecToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->selectLameToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->setupToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->setupACMCodecToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->setupLameToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem2 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->saveID3ToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->gainToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->movePhaseToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->repairClickNoiseToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->repairDCOffsetToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem3 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->checkMaxToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->checkPhaseGapToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->checkClickNoiseToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripSeparator1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->startEncodeToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->stopEncodeToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->priorityToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->highestToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->highToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->normalToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lowToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lowestToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->helpToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->aboutToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->expToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->yToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lvFileList = (gcnew System::Windows::Forms::ListView());
			this->clmStatus = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmArtist = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmAlbum = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmWave = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmGain = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmMax = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmMaxPos = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmLoud = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmPhaseGap = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmMovePhase = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmClickNoiseCount = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmDeClickNoise = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmAverage = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmMoveDcOffset = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmHz = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmBits = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmCh = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmTime = (gcnew System::Windows::Forms::ColumnHeader());
			this->clmMp3 = (gcnew System::Windows::Forms::ColumnHeader());
			this->mainToolStrip = (gcnew System::Windows::Forms::ToolStrip());
			this->checkMaxToolStripButton = (gcnew System::Windows::Forms::ToolStripButton());
			this->startEncodeToolStripButton = (gcnew System::Windows::Forms::ToolStripButton());
			this->stopEncodeToolStripButton = (gcnew System::Windows::Forms::ToolStripButton());
			this->mainStatusStrip = (gcnew System::Windows::Forms::StatusStrip());
			this->mainToolStripProgressBar = (gcnew System::Windows::Forms::ToolStripProgressBar());
			this->openWaveFileDialog = (gcnew System::Windows::Forms::OpenFileDialog());
			this->saveWaveFilesToDialog = (gcnew System::Windows::Forms::FolderBrowserDialog());
			this->saveMergeFileDialog = (gcnew System::Windows::Forms::SaveFileDialog());
			this->saveWaveFileDialog = (gcnew System::Windows::Forms::SaveFileDialog());
			this->fontDialog = (gcnew System::Windows::Forms::FontDialog());
			this->mainMenuStrip->SuspendLayout();
			this->mainToolStrip->SuspendLayout();
			this->mainStatusStrip->SuspendLayout();
			this->SuspendLayout();
			// 
			// mainMenuStrip
			// 
			resources->ApplyResources(this->mainMenuStrip, L"mainMenuStrip");
			this->mainMenuStrip->BackColor = System::Drawing::SystemColors::Control;
			this->mainMenuStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {
				this->fileToolStripMenuItem,
					this->viewToolStripMenuItem, this->audioToolStripMenuItem, this->helpToolStripMenuItem, this->expToolStripMenuItem
			});
			this->mainMenuStrip->Name = L"mainMenuStrip";
			this->mainMenuStrip->RenderMode = System::Windows::Forms::ToolStripRenderMode::System;
			// 
			// fileToolStripMenuItem
			// 
			resources->ApplyResources(this->fileToolStripMenuItem, L"fileToolStripMenuItem");
			this->fileToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->fileToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(10) {
				this->clearFileListToolStripMenuItem,
					this->toolStripMenuItem1, this->addWAVEFileToolStripMenuItem, this->saveFilesToToolStripMenuItem, this->saveWaveFileToolStripMenuItem,
					this->saveMergeFileToolStripMenuItem, this->toolStripSeparator2, this->preferencesToolStripMenuItem, this->toolStripMenuItem4,
					this->exitToolStripMenuItem
			});
			this->fileToolStripMenuItem->Name = L"fileToolStripMenuItem";
			// 
			// clearFileListToolStripMenuItem
			// 
			resources->ApplyResources(this->clearFileListToolStripMenuItem, L"clearFileListToolStripMenuItem");
			this->clearFileListToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->clearFileListToolStripMenuItem->Name = L"clearFileListToolStripMenuItem";
			this->clearFileListToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::clearFileListToolStripMenuItem_Click);
			// 
			// toolStripMenuItem1
			// 
			resources->ApplyResources(this->toolStripMenuItem1, L"toolStripMenuItem1");
			this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
			// 
			// addWAVEFileToolStripMenuItem
			// 
			resources->ApplyResources(this->addWAVEFileToolStripMenuItem, L"addWAVEFileToolStripMenuItem");
			this->addWAVEFileToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->addWAVEFileToolStripMenuItem->Name = L"addWAVEFileToolStripMenuItem";
			this->addWAVEFileToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::addWAVEFileToolStripMenuItem_Click);
			// 
			// saveFilesToToolStripMenuItem
			// 
			resources->ApplyResources(this->saveFilesToToolStripMenuItem, L"saveFilesToToolStripMenuItem");
			this->saveFilesToToolStripMenuItem->Name = L"saveFilesToToolStripMenuItem";
			this->saveFilesToToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::saveFilesToToolStripMenuItem_Click);
			// 
			// saveWaveFileToolStripMenuItem
			// 
			resources->ApplyResources(this->saveWaveFileToolStripMenuItem, L"saveWaveFileToolStripMenuItem");
			this->saveWaveFileToolStripMenuItem->Name = L"saveWaveFileToolStripMenuItem";
			this->saveWaveFileToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::saveWaveFileToolStripMenuItem_Click);
			// 
			// saveMergeFileToolStripMenuItem
			// 
			resources->ApplyResources(this->saveMergeFileToolStripMenuItem, L"saveMergeFileToolStripMenuItem");
			this->saveMergeFileToolStripMenuItem->Name = L"saveMergeFileToolStripMenuItem";
			this->saveMergeFileToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::saveMergeFileToolStripMenuItem_Click);
			// 
			// toolStripSeparator2
			// 
			resources->ApplyResources(this->toolStripSeparator2, L"toolStripSeparator2");
			this->toolStripSeparator2->Name = L"toolStripSeparator2";
			// 
			// preferencesToolStripMenuItem
			// 
			resources->ApplyResources(this->preferencesToolStripMenuItem, L"preferencesToolStripMenuItem");
			this->preferencesToolStripMenuItem->Name = L"preferencesToolStripMenuItem";
			this->preferencesToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::preferencesToolStripMenuItem_Click);
			// 
			// toolStripMenuItem4
			// 
			resources->ApplyResources(this->toolStripMenuItem4, L"toolStripMenuItem4");
			this->toolStripMenuItem4->Name = L"toolStripMenuItem4";
			// 
			// exitToolStripMenuItem
			// 
			resources->ApplyResources(this->exitToolStripMenuItem, L"exitToolStripMenuItem");
			this->exitToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->exitToolStripMenuItem->Name = L"exitToolStripMenuItem";
			this->exitToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::exitToolStripMenuItem_Click);
			// 
			// viewToolStripMenuItem
			// 
			resources->ApplyResources(this->viewToolStripMenuItem, L"viewToolStripMenuItem");
			this->viewToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->fontToolStripMenuItem });
			this->viewToolStripMenuItem->Name = L"viewToolStripMenuItem";
			// 
			// fontToolStripMenuItem
			// 
			resources->ApplyResources(this->fontToolStripMenuItem, L"fontToolStripMenuItem");
			this->fontToolStripMenuItem->Name = L"fontToolStripMenuItem";
			this->fontToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::fontToolStripMenuItem_Click);
			// 
			// audioToolStripMenuItem
			// 
			resources->ApplyResources(this->audioToolStripMenuItem, L"audioToolStripMenuItem");
			this->audioToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->audioToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(16) {
				this->encoderToolStripMenuItem,
					this->setupToolStripMenuItem, this->toolStripMenuItem2, this->saveID3ToolStripMenuItem, this->gainToolStripMenuItem, this->movePhaseToolStripMenuItem,
					this->repairClickNoiseToolStripMenuItem, this->repairDCOffsetToolStripMenuItem, this->toolStripMenuItem3, this->checkMaxToolStripMenuItem,
					this->checkPhaseGapToolStripMenuItem, this->checkClickNoiseToolStripMenuItem, this->toolStripSeparator1, this->startEncodeToolStripMenuItem,
					this->stopEncodeToolStripMenuItem, this->priorityToolStripMenuItem
			});
			this->audioToolStripMenuItem->Name = L"audioToolStripMenuItem";
			// 
			// encoderToolStripMenuItem
			// 
			resources->ApplyResources(this->encoderToolStripMenuItem, L"encoderToolStripMenuItem");
			this->encoderToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->encoderToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {
				this->selectACMCodecToolStripMenuItem,
					this->selectLameToolStripMenuItem
			});
			this->encoderToolStripMenuItem->Name = L"encoderToolStripMenuItem";
			// 
			// selectACMCodecToolStripMenuItem
			// 
			resources->ApplyResources(this->selectACMCodecToolStripMenuItem, L"selectACMCodecToolStripMenuItem");
			this->selectACMCodecToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->selectACMCodecToolStripMenuItem->Name = L"selectACMCodecToolStripMenuItem";
			this->selectACMCodecToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::selectACMCodecToolStripMenuItem_Click);
			// 
			// selectLameToolStripMenuItem
			// 
			resources->ApplyResources(this->selectLameToolStripMenuItem, L"selectLameToolStripMenuItem");
			this->selectLameToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->selectLameToolStripMenuItem->Name = L"selectLameToolStripMenuItem";
			this->selectLameToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::selectLameToolStripMenuItem_Click);
			// 
			// setupToolStripMenuItem
			// 
			resources->ApplyResources(this->setupToolStripMenuItem, L"setupToolStripMenuItem");
			this->setupToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->setupToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {
				this->setupACMCodecToolStripMenuItem,
					this->setupLameToolStripMenuItem
			});
			this->setupToolStripMenuItem->Name = L"setupToolStripMenuItem";
			// 
			// setupACMCodecToolStripMenuItem
			// 
			resources->ApplyResources(this->setupACMCodecToolStripMenuItem, L"setupACMCodecToolStripMenuItem");
			this->setupACMCodecToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->setupACMCodecToolStripMenuItem->Name = L"setupACMCodecToolStripMenuItem";
			this->setupACMCodecToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::setupACMCodecToolStripMenuItem_Click);
			// 
			// setupLameToolStripMenuItem
			// 
			resources->ApplyResources(this->setupLameToolStripMenuItem, L"setupLameToolStripMenuItem");
			this->setupLameToolStripMenuItem->Name = L"setupLameToolStripMenuItem";
			this->setupLameToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::setupLameToolStripMenuItem_Click);
			// 
			// toolStripMenuItem2
			// 
			resources->ApplyResources(this->toolStripMenuItem2, L"toolStripMenuItem2");
			this->toolStripMenuItem2->Name = L"toolStripMenuItem2";
			// 
			// saveID3ToolStripMenuItem
			// 
			resources->ApplyResources(this->saveID3ToolStripMenuItem, L"saveID3ToolStripMenuItem");
			this->saveID3ToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->saveID3ToolStripMenuItem->Name = L"saveID3ToolStripMenuItem";
			this->saveID3ToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::saveID3ToolStripMenuItem_Click);
			// 
			// gainToolStripMenuItem
			// 
			resources->ApplyResources(this->gainToolStripMenuItem, L"gainToolStripMenuItem");
			this->gainToolStripMenuItem->Name = L"gainToolStripMenuItem";
			this->gainToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::gainToolStripMenuItem_Click);
			// 
			// movePhaseToolStripMenuItem
			// 
			resources->ApplyResources(this->movePhaseToolStripMenuItem, L"movePhaseToolStripMenuItem");
			this->movePhaseToolStripMenuItem->Name = L"movePhaseToolStripMenuItem";
			this->movePhaseToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::movePhaseToolStripMenuItem_Click);
			// 
			// repairClickNoiseToolStripMenuItem
			// 
			resources->ApplyResources(this->repairClickNoiseToolStripMenuItem, L"repairClickNoiseToolStripMenuItem");
			this->repairClickNoiseToolStripMenuItem->Name = L"repairClickNoiseToolStripMenuItem";
			this->repairClickNoiseToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::repairClickNoiseToolStripMenuItem_Click);
			// 
			// repairDCOffsetToolStripMenuItem
			// 
			resources->ApplyResources(this->repairDCOffsetToolStripMenuItem, L"repairDCOffsetToolStripMenuItem");
			this->repairDCOffsetToolStripMenuItem->Name = L"repairDCOffsetToolStripMenuItem";
			this->repairDCOffsetToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::repairDCOffsetToolStripMenuItem_Click);
			// 
			// toolStripMenuItem3
			// 
			resources->ApplyResources(this->toolStripMenuItem3, L"toolStripMenuItem3");
			this->toolStripMenuItem3->Name = L"toolStripMenuItem3";
			// 
			// checkMaxToolStripMenuItem
			// 
			resources->ApplyResources(this->checkMaxToolStripMenuItem, L"checkMaxToolStripMenuItem");
			this->checkMaxToolStripMenuItem->Name = L"checkMaxToolStripMenuItem";
			this->checkMaxToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::checkMaxToolStripMenuItem_Click);
			// 
			// checkPhaseGapToolStripMenuItem
			// 
			resources->ApplyResources(this->checkPhaseGapToolStripMenuItem, L"checkPhaseGapToolStripMenuItem");
			this->checkPhaseGapToolStripMenuItem->Name = L"checkPhaseGapToolStripMenuItem";
			this->checkPhaseGapToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::checkPhaseGapToolStripMenuItem_Click);
			// 
			// checkClickNoiseToolStripMenuItem
			// 
			resources->ApplyResources(this->checkClickNoiseToolStripMenuItem, L"checkClickNoiseToolStripMenuItem");
			this->checkClickNoiseToolStripMenuItem->Name = L"checkClickNoiseToolStripMenuItem";
			this->checkClickNoiseToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::checkClickNoiseToolStripMenuItem_Click);
			// 
			// toolStripSeparator1
			// 
			resources->ApplyResources(this->toolStripSeparator1, L"toolStripSeparator1");
			this->toolStripSeparator1->Name = L"toolStripSeparator1";
			// 
			// startEncodeToolStripMenuItem
			// 
			resources->ApplyResources(this->startEncodeToolStripMenuItem, L"startEncodeToolStripMenuItem");
			this->startEncodeToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->startEncodeToolStripMenuItem->Name = L"startEncodeToolStripMenuItem";
			this->startEncodeToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::startEncodeToolStripMenuItem_Click);
			// 
			// stopEncodeToolStripMenuItem
			// 
			resources->ApplyResources(this->stopEncodeToolStripMenuItem, L"stopEncodeToolStripMenuItem");
			this->stopEncodeToolStripMenuItem->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Text;
			this->stopEncodeToolStripMenuItem->Name = L"stopEncodeToolStripMenuItem";
			this->stopEncodeToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::stopEncodeToolStripMenuItem_Click);
			// 
			// priorityToolStripMenuItem
			// 
			resources->ApplyResources(this->priorityToolStripMenuItem, L"priorityToolStripMenuItem");
			this->priorityToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {
				this->highestToolStripMenuItem,
					this->highToolStripMenuItem, this->normalToolStripMenuItem, this->lowToolStripMenuItem, this->lowestToolStripMenuItem
			});
			this->priorityToolStripMenuItem->Name = L"priorityToolStripMenuItem";
			// 
			// highestToolStripMenuItem
			// 
			resources->ApplyResources(this->highestToolStripMenuItem, L"highestToolStripMenuItem");
			this->highestToolStripMenuItem->Name = L"highestToolStripMenuItem";
			this->highestToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::highestToolStripMenuItem_Click);
			// 
			// highToolStripMenuItem
			// 
			resources->ApplyResources(this->highToolStripMenuItem, L"highToolStripMenuItem");
			this->highToolStripMenuItem->Name = L"highToolStripMenuItem";
			this->highToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::highToolStripMenuItem_Click);
			// 
			// normalToolStripMenuItem
			// 
			resources->ApplyResources(this->normalToolStripMenuItem, L"normalToolStripMenuItem");
			this->normalToolStripMenuItem->Name = L"normalToolStripMenuItem";
			this->normalToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::normalToolStripMenuItem_Click);
			// 
			// lowToolStripMenuItem
			// 
			resources->ApplyResources(this->lowToolStripMenuItem, L"lowToolStripMenuItem");
			this->lowToolStripMenuItem->Name = L"lowToolStripMenuItem";
			this->lowToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::lowToolStripMenuItem_Click);
			// 
			// lowestToolStripMenuItem
			// 
			resources->ApplyResources(this->lowestToolStripMenuItem, L"lowestToolStripMenuItem");
			this->lowestToolStripMenuItem->Name = L"lowestToolStripMenuItem";
			this->lowestToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::lowestToolStripMenuItem_Click);
			// 
			// helpToolStripMenuItem
			// 
			resources->ApplyResources(this->helpToolStripMenuItem, L"helpToolStripMenuItem");
			this->helpToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->aboutToolStripMenuItem });
			this->helpToolStripMenuItem->Name = L"helpToolStripMenuItem";
			// 
			// aboutToolStripMenuItem
			// 
			resources->ApplyResources(this->aboutToolStripMenuItem, L"aboutToolStripMenuItem");
			this->aboutToolStripMenuItem->Name = L"aboutToolStripMenuItem";
			this->aboutToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::aboutToolStripMenuItem_Click);
			// 
			// expToolStripMenuItem
			// 
			resources->ApplyResources(this->expToolStripMenuItem, L"expToolStripMenuItem");
			this->expToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->yToolStripMenuItem });
			this->expToolStripMenuItem->Name = L"expToolStripMenuItem";
			// 
			// yToolStripMenuItem
			// 
			resources->ApplyResources(this->yToolStripMenuItem, L"yToolStripMenuItem");
			this->yToolStripMenuItem->Name = L"yToolStripMenuItem";
			this->yToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::yToolStripMenuItem_Click);
			// 
			// lvFileList
			// 
			resources->ApplyResources(this->lvFileList, L"lvFileList");
			this->lvFileList->BorderStyle = System::Windows::Forms::BorderStyle::None;
			this->lvFileList->Columns->AddRange(gcnew cli::array< System::Windows::Forms::ColumnHeader^  >(19) {
				this->clmStatus, this->clmArtist,
					this->clmAlbum, this->clmWave, this->clmGain, this->clmMax, this->clmMaxPos, this->clmLoud, this->clmPhaseGap, this->clmMovePhase,
					this->clmClickNoiseCount, this->clmDeClickNoise, this->clmAverage, this->clmMoveDcOffset, this->clmHz, this->clmBits, this->clmCh,
					this->clmTime, this->clmMp3
			});
			this->lvFileList->FullRowSelect = true;
			this->lvFileList->GridLines = true;
			this->lvFileList->HeaderStyle = System::Windows::Forms::ColumnHeaderStyle::Nonclickable;
			this->lvFileList->Name = L"lvFileList";
			this->lvFileList->UseCompatibleStateImageBehavior = false;
			this->lvFileList->View = System::Windows::Forms::View::Details;
			this->lvFileList->SelectedIndexChanged += gcnew System::EventHandler(this, &FormMain::lvFileList_SelectedIndexChanged);
			// 
			// clmStatus
			// 
			resources->ApplyResources(this->clmStatus, L"clmStatus");
			// 
			// clmArtist
			// 
			resources->ApplyResources(this->clmArtist, L"clmArtist");
			// 
			// clmAlbum
			// 
			resources->ApplyResources(this->clmAlbum, L"clmAlbum");
			// 
			// clmWave
			// 
			resources->ApplyResources(this->clmWave, L"clmWave");
			// 
			// clmGain
			// 
			resources->ApplyResources(this->clmGain, L"clmGain");
			// 
			// clmMax
			// 
			resources->ApplyResources(this->clmMax, L"clmMax");
			// 
			// clmMaxPos
			// 
			resources->ApplyResources(this->clmMaxPos, L"clmMaxPos");
			// 
			// clmLoud
			// 
			resources->ApplyResources(this->clmLoud, L"clmLoud");
			// 
			// clmPhaseGap
			// 
			resources->ApplyResources(this->clmPhaseGap, L"clmPhaseGap");
			// 
			// clmMovePhase
			// 
			resources->ApplyResources(this->clmMovePhase, L"clmMovePhase");
			// 
			// clmClickNoiseCount
			// 
			resources->ApplyResources(this->clmClickNoiseCount, L"clmClickNoiseCount");
			// 
			// clmDeClickNoise
			// 
			resources->ApplyResources(this->clmDeClickNoise, L"clmDeClickNoise");
			// 
			// clmAverage
			// 
			resources->ApplyResources(this->clmAverage, L"clmAverage");
			// 
			// clmMoveDcOffset
			// 
			resources->ApplyResources(this->clmMoveDcOffset, L"clmMoveDcOffset");
			// 
			// clmHz
			// 
			resources->ApplyResources(this->clmHz, L"clmHz");
			// 
			// clmBits
			// 
			resources->ApplyResources(this->clmBits, L"clmBits");
			// 
			// clmCh
			// 
			resources->ApplyResources(this->clmCh, L"clmCh");
			// 
			// clmTime
			// 
			resources->ApplyResources(this->clmTime, L"clmTime");
			// 
			// clmMp3
			// 
			resources->ApplyResources(this->clmMp3, L"clmMp3");
			// 
			// mainToolStrip
			// 
			resources->ApplyResources(this->mainToolStrip, L"mainToolStrip");
			this->mainToolStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {
				this->checkMaxToolStripButton,
					this->startEncodeToolStripButton, this->stopEncodeToolStripButton
			});
			this->mainToolStrip->Name = L"mainToolStrip";
			this->mainToolStrip->RenderMode = System::Windows::Forms::ToolStripRenderMode::System;
			// 
			// checkMaxToolStripButton
			// 
			resources->ApplyResources(this->checkMaxToolStripButton, L"checkMaxToolStripButton");
			this->checkMaxToolStripButton->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->checkMaxToolStripButton->Name = L"checkMaxToolStripButton";
			this->checkMaxToolStripButton->Click += gcnew System::EventHandler(this, &FormMain::checkMaxToolStripButton_Click);
			// 
			// startEncodeToolStripButton
			// 
			resources->ApplyResources(this->startEncodeToolStripButton, L"startEncodeToolStripButton");
			this->startEncodeToolStripButton->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->startEncodeToolStripButton->Name = L"startEncodeToolStripButton";
			this->startEncodeToolStripButton->Click += gcnew System::EventHandler(this, &FormMain::startEncodetoolStripButton_Click);
			// 
			// stopEncodeToolStripButton
			// 
			resources->ApplyResources(this->stopEncodeToolStripButton, L"stopEncodeToolStripButton");
			this->stopEncodeToolStripButton->DisplayStyle = System::Windows::Forms::ToolStripItemDisplayStyle::Image;
			this->stopEncodeToolStripButton->Name = L"stopEncodeToolStripButton";
			this->stopEncodeToolStripButton->Click += gcnew System::EventHandler(this, &FormMain::stopEncodeToolStripButton_Click);
			// 
			// mainStatusStrip
			// 
			resources->ApplyResources(this->mainStatusStrip, L"mainStatusStrip");
			this->mainStatusStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(1) { this->mainToolStripProgressBar });
			this->mainStatusStrip->Name = L"mainStatusStrip";
			// 
			// mainToolStripProgressBar
			// 
			resources->ApplyResources(this->mainToolStripProgressBar, L"mainToolStripProgressBar");
			this->mainToolStripProgressBar->ForeColor = System::Drawing::SystemColors::HotTrack;
			this->mainToolStripProgressBar->Name = L"mainToolStripProgressBar";
			this->mainToolStripProgressBar->Step = 1;
			this->mainToolStripProgressBar->Style = System::Windows::Forms::ProgressBarStyle::Continuous;
			// 
			// openWaveFileDialog
			// 
			resources->ApplyResources(this->openWaveFileDialog, L"openWaveFileDialog");
			this->openWaveFileDialog->Multiselect = true;
			// 
			// saveWaveFilesToDialog
			// 
			resources->ApplyResources(this->saveWaveFilesToDialog, L"saveWaveFilesToDialog");
			// 
			// saveMergeFileDialog
			// 
			resources->ApplyResources(this->saveMergeFileDialog, L"saveMergeFileDialog");
			// 
			// saveWaveFileDialog
			// 
			resources->ApplyResources(this->saveWaveFileDialog, L"saveWaveFileDialog");
			this->saveWaveFileDialog->FileOk += gcnew System::ComponentModel::CancelEventHandler(this, &FormMain::saveWaveFileDialog_FileOk);
			// 
			// FormMain
			// 
			resources->ApplyResources(this, L"$this");
			this->AllowDrop = true;
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->Controls->Add(this->mainStatusStrip);
			this->Controls->Add(this->mainToolStrip);
			this->Controls->Add(this->lvFileList);
			this->Controls->Add(this->mainMenuStrip);
			this->MainMenuStrip = this->mainMenuStrip;
			this->Name = L"FormMain";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &FormMain::FormMain_FormClosing);
			this->Load += gcnew System::EventHandler(this, &FormMain::FormMain_Load);
			this->DragDrop += gcnew System::Windows::Forms::DragEventHandler(this, &FormMain::FormMain_DragDrop);
			this->DragEnter += gcnew System::Windows::Forms::DragEventHandler(this, &FormMain::FormMain_DragEnter);
			this->mainMenuStrip->ResumeLayout(false);
			this->mainMenuStrip->PerformLayout();
			this->mainToolStrip->ResumeLayout(false);
			this->mainToolStrip->PerformLayout();
			this->mainStatusStrip->ResumeLayout(false);
			this->mainStatusStrip->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

		TCriticalSection *m_csFileList;
		TAudioFileProcess *m_files;
		TGenericCallbackGlue^ m_encodeProgress;
		TGenericCallbackGlue^ m_encodeFinishOne;
		TGenericCallbackGlue^ m_commonProgress;
		TGenericCallbackGlue^ m_commonStartOne;
		TGenericCallbackGlue^ m_commonFinishOne;
		TGenericCallbackGlue^ m_commonFinish;
		ArrayList^ m_priorities;
		String^ m_saveFileAsOrgFilePath;

		bool AddWaveFileWithDlalog();
		bool AddWaveFile(const std::wstring &waveFilePath);
		TAudioFile *GetAudioFileByWaveFilePath(const std::wstring &waveFilePath);
		ListViewItem^ GetListViewItemByAudioFile(TAudioFile *af);
		void CallbackEncodeProgress(TGenericCallbackParam^ param);
		void CallbackEncodeFinishOne(TGenericCallbackParam^ param);
		void CallbackCommonStartOne(TGenericCallbackParam^ param);
		void CallbackCommonProgress(TGenericCallbackParam^ param);
		void CallbackCommonFinishOne(TGenericCallbackParam^ param);
		void CallbackCommonFinish(TGenericCallbackParam^ param);
		void LoadPrefFile();
		void SavePrefFile();
		void FixMenu();
		void SetPriority(ToolStripMenuItem^ item);
		void SaveFilesTo();
		void SaveMergeFile();
		void SaveFileAs();
		void Gain();
		void MovePhase();
		void Differentiate();
		void CheckMaxDecibel();
		void CheckPhaseGap();
		void CheckClickNoise();
		void RepairClickNoise();
		void DCOffset();

	private:
		System::Void FormMain_DragDrop(System::Object^ sender, System::Windows::Forms::DragEventArgs^ e) {
			std::list<std::wstring> list;
			Array^ s = (Array^)e->Data->GetData(DataFormats::FileDrop, false);
			for (int i = 0; i < s->Length; i++) {
				String^ path = (String^)s->GetValue(i);
				list.push_back(TStringUtil::MarshalString(path));
			}
			list.sort();
			while (list.size() > 0) {
				AddWaveFile(list.front());
				list.pop_front();
			}
			FixMenu();
		}

		System::Void FormMain_DragEnter(System::Object^ sender, System::Windows::Forms::DragEventArgs^ e) {
			e->Effect = e->Data->GetDataPresent(DataFormats::FileDrop) ? DragDropEffects::All : DragDropEffects::None;
		}

		System::Void startEncodeToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->StartEncode();
			FixMenu();
		}

		System::Void stopEncodeToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->Stop();
			FixMenu();
		}

		System::Void clearFileListToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			lvFileList->Items->Clear();
			m_files->RemoveDeleteAll();
			FixMenu();
		}

		System::Void FormMain_Load(System::Object^  sender, System::EventArgs^  e);
		
		System::Void FormMain_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) {
			if (m_files->IsWorking()) {
				m_files->PauseEncode(true);
				if (MessageBox::Show(L"Exit ?", L"Working", MessageBoxButtons::OKCancel) != System::Windows::Forms::DialogResult::OK) {
					e->Cancel = true;
					m_files->PauseEncode(false);
					return;
				}
				else {
					m_encodeProgress->Disable();
					m_encodeFinishOne->Disable();
					m_files->Stop();
				}
			}
			SavePrefFile(); 
		}

		System::Void saveID3ToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			Prefs::data->saveID3 = (!Prefs::data->saveID3);
			FixMenu();
		}

		System::Void exitToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			Close();
		}

		System::Void startEncodetoolStripButton_Click(System::Object^  sender, System::EventArgs^  e) {
			startEncodeToolStripMenuItem_Click(sender, e);
		}

		System::Void addWAVEFileToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			AddWaveFileWithDlalog();
			FixMenu();
		}

		System::Void setupACMCodecToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->m_acmEncoder.Setup((HWND)Handle.ToInt32());
			FixMenu();
		}

		System::Void selectACMCodecToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->m_selectedEncoder = &m_files->m_acmEncoder;
			FixMenu();
		}

		System::Void selectLameToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->m_selectedEncoder = &m_files->m_lameEncoder;
			FixMenu();
		}

		System::Void stopEncodeToolStripButton_Click(System::Object^  sender, System::EventArgs^  e) {
			stopEncodeToolStripMenuItem_Click(sender, e);
		}

		System::Void setupLameToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			m_files->m_lameEncoder.Setup((HWND)Handle.ToInt32());
			FixMenu();
		}

		System::Void highestToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SetPriority(highestToolStripMenuItem);
			FixMenu();
		}

		System::Void highToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SetPriority(highToolStripMenuItem);
			FixMenu();
		}

		System::Void normalToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SetPriority(normalToolStripMenuItem);
			FixMenu();
		}

		System::Void lowToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SetPriority(lowToolStripMenuItem);
			FixMenu();
		}

		System::Void lowestToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SetPriority(lowestToolStripMenuItem);
			FixMenu();
		}

		System::Void saveFilesToToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SaveFilesTo();
			FixMenu();
		}

		System::Void saveMergeFileToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SaveMergeFile();
			FixMenu();
		}

		System::Void gainToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			Gain();
			FixMenu();
		}

		System::Void checkMaxToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			CheckMaxDecibel();
			FixMenu();
		}

		System::Void aboutToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			FormAboutDlg^ dlg = gcnew FormAboutDlg();
			dlg->ShowDialog(this);
		}

		System::Void checkMaxToolStripButton_Click(System::Object^  sender, System::EventArgs^  e) {
			 checkMaxToolStripMenuItem_Click(sender, e);
		}

		System::Void lvFileList_SelectedIndexChanged(System::Object^  sender, System::EventArgs^  e) {
			FixMenu();
		}
private: System::Void checkPhaseGapToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			CheckPhaseGap();
			FixMenu();
		 }
private: System::Void movePhaseToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			MovePhase();
			FixMenu();
		 }
private: System::Void yToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			Differentiate();
			FixMenu();
		 }
private: System::Void checkClickNoiseToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			CheckClickNoise();
			FixMenu();
		 }
private: System::Void repairClickNoiseToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			RepairClickNoise();
			FixMenu();
		 }
private: System::Void saveWaveFileToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			SaveFileAs();
			FixMenu();
		 }
private: System::Void saveWaveFileDialog_FileOk(System::Object^  sender, System::ComponentModel::CancelEventArgs^  e) {
			if (m_saveFileAsOrgFilePath == saveWaveFileDialog->FileName)
				e->Cancel = true;
		 }
private: System::Void repairDCOffsetToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e) {
			DCOffset();
			FixMenu();
		 }
private: System::Void fontToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e);
private: System::Void preferencesToolStripMenuItem_Click(System::Object^  sender, System::EventArgs^  e);

};
}
