#include "stdafx.h"
#include "TGlobal.h"
#include "TDCOffsetFilter.h"
#include <math.h>

#pragma managed(push, off)

void TDCOffsetFilter::Init() {
	m_dbLeft = 0.0;
	m_dbRight = 0.0;
	m_bits = 0;
}

TDCOffsetFilter::TDCOffsetFilter() {
	Init();
}

TDCOffsetFilter::TDCOffsetFilter(int bits, double dbLeft, bool bLeftDown, double dbRight, bool bRightDown) {
	Init();
	Setup(bits, dbLeft, bLeftDown, dbRight, bRightDown);
}

void TDCOffsetFilter::Setup(int bits, double dbLeft, bool bLeftDown, double dbRight, bool bRightDown) {
	m_bits = bits;
	m_dbLeft = dbLeft;
	m_bLeftDown = bLeftDown;
	m_dbRight = dbRight;
	m_bRightDown = bRightDown;
	m_maxLogicalValue = pow((double)2.0, m_bits - 1) - 1.0;
	m_minLogicalValue = -pow((double)2.0, m_bits - 1);
	m_maxLogicalDecibel = log10(pow((double)2.0, m_bits - 1));
	m_sampleLeft = long(pow(10, m_dbLeft / 20.0 + m_maxLogicalDecibel) - 1.0);
	m_sampleRight = long(pow(10, m_dbRight / 20.0 + m_maxLogicalDecibel) - 1.0);
}

long TDCOffsetFilter::ChangeDCOffset(int ch, long inData) {
	long result = 0;
	if (ch == 0) {
		if (m_bLeftDown)
			result = inData - m_sampleLeft;
		else
			result = inData + m_sampleLeft;
	}
	else {
		if (m_bRightDown)
			result = inData - m_sampleRight;
		else
			result = inData + m_sampleRight;
	}
	return result;
}

#pragma managed(pop)

