#include "stdafx.h"
#include "TGlobal.h"
#include "TFileIO.h"

#pragma managed(push, off)

#define TFILEIO_BUFFER_SIZE		(1024 * 31)
/*
	TFileReaderŎ͂ł̃obt@O߂ăCũobt@OɔC悤ύXB
	włobt@̑傫VC6ł32KByteAVC2008łintőlɂȂĂB
	2010.08.24
	Cũobt@fseekŃtbV炵ASeek𑽗p邱̃vOł
	ȂxȂB̓obt@Oɖ߂B
	obt@2dȂǂȂœK͏hB
	2010.08.24
*/

TFileReader::TFileReader(const std::wstring &path) {
	m_fp = NULL;
	m_fileSize = 0;
	m_buffer = NULL;
	m_filePos = 0;
	m_readFilePos = 0;
	m_bufferPos = 0;
	m_bufferTopFilePos = 0;
	struct _stat status;
	if (_wstat(path.c_str(), &status) == -1)
		return;
	m_fileSize = status.st_size;
	m_fp = _wfopen(path.c_str(), _T("rb"));
	m_buffer = new char[TFILEIO_BUFFER_SIZE + 128];
}

TFileReader::~TFileReader() {
	Close();
	if (m_buffer != NULL)
		delete [] m_buffer;
}

void TFileReader::Close() {
	if (m_fp != NULL)
		fclose(m_fp);
	m_fp = NULL;
}

void TFileReader::Fill() {
	size_t readBytes = m_fileSize - m_filePos;
	if (readBytes > TFILEIO_BUFFER_SIZE)
		readBytes = TFILEIO_BUFFER_SIZE;
	readBytes = fread(m_buffer, 1, readBytes, m_fp);
	m_bufferTopFilePos = m_filePos;
	m_readFilePos += readBytes;
}

int TFileReader::GetChar() {
	if (m_fp == NULL)
		return EOF;
	if (m_filePos == m_fileSize)
		return EOF;
	if (m_filePos == m_readFilePos) {
		Fill();
	}
	int ch = (m_buffer[m_bufferPos] & 0xFF);
	m_bufferPos++;
	m_filePos++;
	if (m_bufferPos == TFILEIO_BUFFER_SIZE) {
		m_bufferPos = 0;
	}
	return ch;
}

size_t TFileReader::Read(void *data, size_t count) {
	BYTE *p = (BYTE *)data;
	for (size_t i = 0; i < count; i++) {
		p[i] = (GetChar() & 0xFF);
	}
	return count;
}

int TFileReader::Seek(long offset, int origin) {
	int result = 0;
	size_t newFilePos = m_filePos; 
	if (origin == SEEK_SET) {
		newFilePos = offset;
	}
	else if (origin == SEEK_CUR) {
		newFilePos += offset;
	}
	else if (origin == SEEK_END) {
		newFilePos = m_fileSize + offset;
	}
	if (newFilePos >= m_bufferTopFilePos && newFilePos < m_readFilePos) {
		m_bufferPos = newFilePos - m_bufferTopFilePos;
		m_filePos = newFilePos;
	}
	else {
		result = fseek(m_fp, offset, origin);
		m_bufferTopFilePos = newFilePos;
		m_filePos = m_bufferTopFilePos;
		m_readFilePos = m_filePos;
		m_bufferPos = 0;
	}
	return result;
}

bool TFileReader::IsOK() {
	return m_fp != NULL;
}

size_t TFileReader::GetFileSize() {
	return m_fileSize;
}

bool TFileReader::IsExist(const std::wstring &path) {
	struct _stat status;
	return _wstat(path.c_str(), &status) == 0;
}

bool TTextFileReader::ReadLine(std::string *s) {
	*s = "";
	while (true) {
		int data = m_fr->GetChar();
		if (data == EOF)
			return s->length() != 0;
		if (data == '\r')
			continue;
		if (data == '\n')
			break;
		*s += (char)(data & 0xFF);
	}
	return true;
}

TFileWriter::TFileWriter(const std::wstring &path) {
	m_buffer = NULL;
	m_bufferPos = 0;
	m_fp = _wfopen(path.c_str(), _T("wb+"));
	m_buffer = new char[TFILEIO_BUFFER_SIZE + 128];
}

TFileWriter::~TFileWriter() {
	Close();
	if (m_buffer != NULL)
		delete [] m_buffer;
}

void TFileWriter::PutChar(int data) {
	m_buffer[m_bufferPos] = (data & 0xFF);
	m_bufferPos++;
	if (m_bufferPos == TFILEIO_BUFFER_SIZE)
		Flush();
}

size_t TFileWriter::Write(void *data, size_t count) {
	BYTE *p = (BYTE *)data;
	for (size_t i = 0; i < count; i++) {
		PutChar(p[i] & 0xFF);
	}
	return count;
}


void TFileWriter::Flush() {
	if (m_bufferPos > 0)
		fwrite(m_buffer, 1, m_bufferPos, m_fp);
	m_bufferPos = 0;
}

void TFileWriter::Close() {
	if (m_fp != NULL) {
		Flush();
		fclose(m_fp);
	}
	m_fp = NULL;
}

size_t TFileWriter::Tell() {
	Flush();
	return ftell(m_fp);
}

int TFileWriter::Seek(long offset, int origin) {
	Flush();
	return fseek(m_fp, offset, origin);
}

FILE *TFileWriter::GetFp() {
	Flush();
	return m_fp;
}

#pragma managed(pop)
