#ifndef _TFILEIO_H_
#define _TFILEIO_H_

#pragma managed(push, off)

class TFileReader {
protected:
	size_t m_fileSize;
	FILE *m_fp;
	char *m_buffer;
	/**/
	size_t m_readFilePos;
	size_t m_filePos;
	size_t m_bufferPos;
	size_t m_bufferTopFilePos;
	void Fill();
public:
	TFileReader(const std::wstring &path);
	~TFileReader();
	int GetChar();
	size_t Read(void *data, size_t count);
	int Seek(long offset, int origin);
	void Close();
	bool IsOK();
	size_t GetFileSize();
	static bool IsExist(const std::wstring &path);
};

class TTextFileReader {
public:
	TFileReader *m_fr;
	TTextFileReader(const std::wstring &path) {
		m_fr = new TFileReader(path);
	}
	~TTextFileReader() {
		delete m_fr;
	}
	bool IsOK() {
		return m_fr->IsOK();
	}
	bool ReadLine(std::string *s);
};

class TFileWriter {
protected:
	FILE *m_fp;
	char *m_buffer;
	size_t m_bufferPos;
public:
	TFileWriter(const std::wstring &path);
	~TFileWriter();
	bool IsOK() {
		return m_fp != NULL;
	}
	void PutChar(int data);
	size_t Write(void *data, size_t count);
	void Close();
	void Flush();
	size_t Tell();
	int Seek(long offset, int origin);
	FILE *GetFp();
};

#pragma managed(pop)

#endif
