#ifndef _TPREF_H_
#define _TPREF_H_

#include "TAudioFile.h"

using namespace System;
using namespace System::IO;
using namespace System::Xml;
using namespace System::Xml::Serialization;
using namespace System::Drawing;
using namespace System::Collections::Generic;

#define CURRENT_PREF_VERSION		3
//#define FILE_LIST_COLUMN_COUNT		15

public ref class Preferences {
public:
	int version = CURRENT_PREF_VERSION;
	System::Drawing::Rectangle windowBounds = System::Drawing::Rectangle(100, 100, 400, 200);
	// column
	int statusW = 30;
	int artistW = 80;
	int albumW = 80;
	int waveW = 100;
	int gainW = 30;
	int maxDecibelW = 30;
	int maxSamplePosW = 30;
	int laudDecibelW = 30;
	int phaseGapW = 30;
	int movePhaseW = 30;
	int clickNoiseCountW = 30;
	int repairClickNoiseW = 30;
	int averageW = 30;
	int moveDcOffsetW = 30;
	int hzW = 30;
	int bitsW = 30;
	int chW = 30;
	int timeW = 30;
	int mp3W = 80;
	//
	bool saveID3 = false;
	String^ waveDirPath = _T("");
	String^ saveToDirPath = _T("");
	String^ encoder = _T(ENCODER_NAME_ACM);
	int priority = THREAD_PRIORITY_LOWEST;
	// FixPhase
	long unitCount = 8000;
	long edgeCount = 20;
	double checkLevel = -20.0;
	bool enableOne = true;
	long gapHint = 0;
	// gain
	double gainLaud = -16.0;
	// 
	bool simpleLame = true;
	// Click Noise
	int clickNoiseThrAvrMag1 = 15;
	int clickNoiseThrAvrMag2 = 20;
	double clickNoiseThrFix = -50.0;
	int clickNoiseCvgThrAvrMag = 3;
	//int clickNoiseCvgCount;
	int clickNoiseAvrCount = 20;
	int clickNoiseMaxDistance = 128;
	bool saveLogOnCheckClickNoise = false;
	bool repairOnCheckClickNoise = false;
	bool clickNoiseLeft = true;
	bool clickNoiseRight = true;
	// exp
	bool exp = false;
	// font
	String^ fontFamily = System::Drawing::SystemFonts::MessageBoxFont->FontFamily->Name;
	double fontSize = System::Drawing::SystemFonts::MessageBoxFont->Size;
	bool applyFontToDialog = true;
	//
	Preferences();
	List<int>^ GetColumnWidth();
	void SetColumnWidth(List<int>^ list);
	static String^ GetPrefDirPath();
	static String^ GetPrefFilePath();
	bool Save();
	static Preferences^ Load();
	Font^ GetDialogFont();
};

public ref class Prefs {
public:
	static Preferences^ data = Preferences::Load();
};

#endif
