#ifndef _TTOOLS_H_
#define _TTOOLS_H_

using namespace System;
using namespace System::Runtime::InteropServices;

class TStringUtil {
public:
	//
	// }l[W̕A}l[W̕ɂB
	//
	static std::wstring MarshalString(String^ s);
	//
	static int Split(const std::string &line, const std::string &dlmt, std::vector<std::string> *slist);
	static bool IsDigit(const std::string &s);
	static int ToInteger(const std::string &s);
	static int ToInteger(String^ s);
	static std::string ToAnsi(const std::wstring &s);
	static std::wstring ToUnicode(const std::string &s);
};

//
// A}l[W}l[WփR[obN邽߂̎dg݂܂Ƃ߂NXŎg֐̌^B
// CALLBACK܂WINAPItȂƃX^bNt[̂ŒӁB
//
typedef void (CALLBACK *TGENERIC_CALLBACK)(void *);

//
// A}l[W}l[WփR[obN邽߂̎dg݂܂Ƃ߂NXŎgp^NXB
//
public ref class TGenericCallbackParam {
protected:
	void *m_param;
public:
	TGenericCallbackParam(void *param) {
		m_param = param;
	}
	void *GetParam() {
		return m_param;
	}
};

//
// A}l[W}l[WփR[obN邽߂̎dg݂܂Ƃ߂NXB
//
public ref class TGenericCallbackGlue {
public:
	delegate void GlueDelegate(void *);
	delegate void CallbackDelegate(TGenericCallbackParam^);

protected:
	GlueDelegate^ m_glueDelegate;
	GCHandle m_gch;
	TGENERIC_CALLBACK m_glue;
	CallbackDelegate^ m_callback;
	System::Windows::Forms::Control^ m_control;
	bool m_enable;
	void GlueFunction(void *param);
public:
	TGenericCallbackGlue(System::Windows::Forms::Control^ control, CallbackDelegate^ callback);
	TGENERIC_CALLBACK GetGlue() {
		return m_glue;
	}
	void Disable() {
		m_enable = false;
	}
};

/*
class TPrivateProfile {
public:
	std::wstring m_filePath;
	TPrivateProfile(const std::wstring &filePath);
	void PutString(const std::wstring &section, const std::wstring &key, const std::wstring &value);
	void PutInteger(const std::wstring &section, const std::wstring &key, int value);
	void PutBool(const std::wstring &section, const std::wstring &key, bool value);
	std::wstring GetString(const std::wstring &section, const std::wstring &key, const std::wstring &defaultValue);
	int GetInteger(const std::wstring &section, const std::wstring &key, int defaultValue);
	bool GetBool(const std::wstring &section, const std::wstring &key, bool defaultValue);
};
*/

class TByteBuffer {
public:
	BYTE *m_buffer;
	size_t m_size;
	TByteBuffer(size_t sz) {
		m_size = sz;
		m_buffer = new BYTE[m_size];
		memset(m_buffer, 0, m_size * sizeof(BYTE));
	}
	~TByteBuffer() {
		delete [] m_buffer;
	}
};

class TLongBuffer {
public:
	long *m_buffer;
	size_t m_size;
	TLongBuffer(size_t sz) {
		m_size = sz;
		m_buffer = new long[m_size];
		memset(m_buffer, 0, m_size * sizeof(long));
	}
	~TLongBuffer() {
		delete [] m_buffer;
	}
};

class TValueTable {
public:
	std::wstring m_name;
	int m_value;
	TValueTable(LPCTSTR name, int value) {
		m_name = name;
		m_value = value;
	}
};

class TCriticalSection {
protected:
	CRITICAL_SECTION m_cs;
public:
	TCriticalSection() {
		::InitializeCriticalSection(&m_cs);
	}
	~TCriticalSection() {
		::DeleteCriticalSection(&m_cs);
	}
	void Enter() {
		::EnterCriticalSection(&m_cs);
	}
	void Leave() {
		::LeaveCriticalSection(&m_cs);
	}
};

class TCriticalSectionEnter {
protected:
	TCriticalSection *m_cs;
public:
	TCriticalSectionEnter(TCriticalSection *cs) {
		m_cs = cs;
		m_cs->Enter();
	}
	~TCriticalSectionEnter() {
		m_cs->Leave();
	}
};

class TTempFile {
protected:
	std::string m_path;
public:
	TTempFile(char *prefix) {
		const char *path = _tempnam(NULL, prefix);
		if (path == NULL)
			return;
		m_path = path;
	}
	~TTempFile() {
		remove(m_path.c_str());
	}
	std::string GetPath() {
		return m_path;
	}
	std::wstring GetUniPath() {
		std::wstring unipath;
		const char *path = m_path.c_str();
		for (size_t i = 0; i < strlen(path); i++)
			unipath += path[i];
		return unipath;
	}
};

// long̕ϒlB
class TAverageOfLong {
	long *m_buffer;
	int m_pos;
	int m_count;
	long long m_sum;
public:
	TAverageOfLong() {
		m_pos = 0;
		m_count = 0;
		m_sum = 0;
		m_buffer = NULL;
	}
	~TAverageOfLong() {
		if (m_buffer != NULL)
			delete [] m_buffer;
	}
	void Setup(int count) {
		m_count = count;
		m_buffer = new long[m_count];
		for (int i = 0; i < m_count; i++)
			m_buffer[i] = 0;
	}
	long GetAverage() {
		return long(m_sum / m_count);
	}
	void Add(long v) {
		AddAbs(abs(v));
	}
	void AddAbs(long av) {
		m_sum -= m_buffer[m_pos];
		m_buffer[m_pos] = av;
		m_sum += m_buffer[m_pos];
		m_pos++;
		if (m_pos < m_count) {
		}
		else {
			m_pos = 0;
		}
	}
};

#endif _TTOOLS_H_
